#include <avr/io.h>
#include <avr/interrupt.h>

#include "ADC_sensors.h"

volatile uint16_t ADC_value[ADC_MAX_CHANNELS];

ISR(ADC_vect)
{
	// Intreruperea este triggered cand o conversie este finalizata. */
	static uint8_t channel = ADC_INIT_CHANNEL;
	ADC_value[channel] = ADC;
	// aleg canalul si pornesc conversia
	channel = (channel + 1) % ADC_MAX_CHANNELS;
	ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;

    // Pornim ADC-ul daca le-am citit pe toate.
    if (channel != ADC_INIT_CHANNEL)
        ADCSRA |= (1 << ADSC);
}


ISR(TIMER1_COMPA_vect)
{
    // start ADC conversion
    ADCSRA |= (1 << ADSC);
}

/*
 * Functia initializeaza Timer1 pentru a genera o intrerupere care sa
 * porneasca ADC-ul la fiecare 100ms.
 */
void TIMER1_init()
{
    // initializare timer pentru COMPA la 100ms
    TCCR1B = (5 << CS10) | (1 << WGM12);
    TIMSK1 |= (1 << OCIE1A);
    OCR1A = 1561;
}

uint16_t ADC_get(uint8_t channel)
{
    return ADC_value[channel];
}

