#ifndef ADC_H_
#define ADC_H_

#define ADC_MAX_CHANNELS 4

/* Numele canalelor de ADC. */
typedef struct
{
  const char *name;
  uint8_t    channel;
} adc_channel_t;
 
/* Perechi de (Nume canal, Numar canal). */
const adc_channel_t ADC_channels[] = {
  // Senzor de umiditate sol conenctat la ADC0
  {"Umiditate", 0},

  // Senzor de lumina conectat la ADC1
  {"Lumina", 1},

  // Senzor de nivel
  {"Nivel", 2},

  // Senzor de temperatura
  {"Temperatura", 3}

};

/* Numarul de canale ADC utilizate. */
const int adc_num_channels = sizeof(ADC_channels) / sizeof(ADC_channels[0]);

/* Numarul canalului initial. */
#  define ADC_INIT_CHANNEL 0

// Initializare timer
void TIMER1_init();

// Citire
uint16_t ADC_get(uint8_t channel);

#endif
